---
title: Customize the Toolbar
product: Survey Creator
description: Enhance Survey Creator's functionality by adding a custom toolbar button. View our free demo for JavaScript that shows how to integrate a custom button that clears the survey displayed on the design surface.
framework: Vanilla JS
source: https://surveyjs.io/survey-creator/examples/toolbar-customization/vanillajs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Customize the Toolbar (Vanilla JS)

Survey Creator's toolbar contains buttons that perform actions relevant to the active tab. For instance, the Designer tab allows users to undo and redo last operations, the Preview tab&mdash;change the device type and orientation, and the JSON Editor tab&mdash;import and export the survey JSON schema. This demo shows how to add a custom toolbar button that clears the survey on the design surface.

## Configure a Toolbar Button

To configure a toolbar button, define an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) object. Within it, you can set the button's [unique ID](https://surveyjs.io/form-library/documentation/api-reference/iaction#id), [icon](https://surveyjs.io/form-library/documentation/api-reference/iaction#iconName), [tooltip](https://surveyjs.io/form-library/documentation/api-reference/iaction#tooltip), and other parameters. You should also specify a function that this button will call and assign it to the [`action`](https://surveyjs.io/form-library/documentation/api-reference/iaction#action) property. In this demo, the `action` function sets the Survey Creator's [`JSON`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#JSON) property to an empty object, thus clearing the survey users configure. 

```js
import { Action } from "survey-core";

const clearSurveyAction = new Action({
    id: "clear-survey",
    tooltip: "Clear Survey",
    iconName: "icon-clear-24x24",
    action: () => {
        creator.JSON = {};
    }
});
```

Different tabs can have different toolbar buttons. To control the toolbar button visibility, use the `IAction` object's [`visible`](https://surveyjs.io/form-library/documentation/api-reference/iaction#visible) property. You can set it to a static Boolean value or to a `ComputedUpdater` instance if you need to calculate the property value dynamically. The `ComputedUpdater` constructor accepts a function that specifies the calculation rules. This function will be reevaluated each time a dependency property is changed. In this demo, the `visible` property depends on the Survey Creator's [`activeTab`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#activeTab) property:

```js
const clearSurveyAction = new Action({
    // ...
    visible: new ComputedUpdater(() => creator.activeTab === "designer")
});
```

## Add the Button to the Toolbar

Survey Creator includes two toolbars: top (for the desktop view) and bottom (for the mobile view). You can add your custom button to both or only one of the toolbars: 

```js
// Add a custom button to the top toolbar
creator.toolbar.actions.push(clearSurveyAction);

// Add a custom button to the bottom toolbar
creator.footerToolbar.actions.push(clearSurveyAction);
```

Open the Code tab to view the code example in full.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { SurveyCreator } from "survey-creator-js";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Action, ComputedUpdater } from "survey-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

const creator = new SurveyCreator();

const clearSurveyAction = new Action({
    id: "clear-survey",
    tooltip: "Clear Survey",
    iconName: "icon-clear-24x24",
    visible: new ComputedUpdater(() => creator.activeTab === "designer"),
    action: () => {
        creator.JSON = {};
    }
});

// Add a custom button to the top toolbar
creator.toolbar.actions.push(clearSurveyAction);

// Add a custom button to the bottom toolbar (visible only on mobile devices)
creator.footerToolbar.actions.push(clearSurveyAction);

creator.JSON = {
    "pages": [{
        "name": "page1",
        "elements": [{
            "type": "text",
            "name": "question1"
        }]
    }]
};
creator.render("surveyCreatorContainer");
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-js": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/toolbar-customization/angular.md)
- [React](https://surveyjs.io/survey-creator/examples/toolbar-customization/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/toolbar-customization/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/toolbar-customization/jquery.md)


---
title: Customize the Toolbar
product: Survey Creator
description: Enhance Survey Creator's functionality by adding a custom toolbar button. View our free demo for JavaScript that shows how to integrate a custom button that clears the survey displayed on the design surface.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/toolbar-customization/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Customize the Toolbar (Angular)

Survey Creator's toolbar contains buttons that perform actions relevant to the active tab. For instance, the Designer tab allows users to undo and redo last operations, the Preview tab&mdash;change the device type and orientation, and the JSON Editor tab&mdash;import and export the survey JSON schema. This demo shows how to add a custom toolbar button that clears the survey on the design surface.

## Configure a Toolbar Button

To configure a toolbar button, define an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) object. Within it, you can set the button's [unique ID](https://surveyjs.io/form-library/documentation/api-reference/iaction#id), [icon](https://surveyjs.io/form-library/documentation/api-reference/iaction#iconName), [tooltip](https://surveyjs.io/form-library/documentation/api-reference/iaction#tooltip), and other parameters. You should also specify a function that this button will call and assign it to the [`action`](https://surveyjs.io/form-library/documentation/api-reference/iaction#action) property. In this demo, the `action` function sets the Survey Creator's [`JSON`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#JSON) property to an empty object, thus clearing the survey users configure. 

```js
import { Action } from "survey-core";

const clearSurveyAction = new Action({
    id: "clear-survey",
    tooltip: "Clear Survey",
    iconName: "icon-clear-24x24",
    action: () => {
        creator.JSON = {};
    }
});
```

Different tabs can have different toolbar buttons. To control the toolbar button visibility, use the `IAction` object's [`visible`](https://surveyjs.io/form-library/documentation/api-reference/iaction#visible) property. You can set it to a static Boolean value or to a `ComputedUpdater` instance if you need to calculate the property value dynamically. The `ComputedUpdater` constructor accepts a function that specifies the calculation rules. This function will be reevaluated each time a dependency property is changed. In this demo, the `visible` property depends on the Survey Creator's [`activeTab`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#activeTab) property:

```js
const clearSurveyAction = new Action({
    // ...
    visible: new ComputedUpdater(() => creator.activeTab === "designer")
});
```

## Add the Button to the Toolbar

Survey Creator includes two toolbars: top (for the desktop view) and bottom (for the mobile view). You can add your custom button to both or only one of the toolbars: 

```js
// Add a custom button to the top toolbar
creator.toolbar.actions.push(clearSurveyAction);

// Add a custom button to the bottom toolbar
creator.footerToolbar.actions.push(clearSurveyAction);
```

Open the Code tab to view the code example in full.

## Files

### `src/app/components/creator.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Action, ComputedUpdater } from "survey-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel();
        const clearSurveyAction = new Action({
            id: "clear-survey",
            tooltip: "Clear Survey",
            iconName: "icon-clear-24x24",
            visible: new ComputedUpdater(() => creator.activeTab === "designer"),
            action: () => {
                creator.JSON = {};
            }
        });
        
        // Add a custom button to the top toolbar
        creator.toolbar.actions.push(clearSurveyAction);
        
        // Add a custom button to the bottom toolbar (visible only on mobile devices)
        creator.footerToolbar.actions.push(clearSurveyAction);
        
        creator.JSON = {
            "pages": [{
                "name": "page1",
                "elements": [{
                    "type": "text",
                    "name": "question1"
                }]
            }]
        };
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/toolbar-customization/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/toolbar-customization/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/toolbar-customization/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/toolbar-customization/vanillajs.md)


---
title: Customize the Toolbar
product: Survey Creator
description: Enhance Survey Creator's functionality by adding a custom toolbar button. View our free demo for JavaScript that shows how to integrate a custom button that clears the survey displayed on the design surface.
framework: React
source: https://surveyjs.io/survey-creator/examples/toolbar-customization/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Customize the Toolbar (React)

Survey Creator's toolbar contains buttons that perform actions relevant to the active tab. For instance, the Designer tab allows users to undo and redo last operations, the Preview tab&mdash;change the device type and orientation, and the JSON Editor tab&mdash;import and export the survey JSON schema. This demo shows how to add a custom toolbar button that clears the survey on the design surface.

## Configure a Toolbar Button

To configure a toolbar button, define an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) object. Within it, you can set the button's [unique ID](https://surveyjs.io/form-library/documentation/api-reference/iaction#id), [icon](https://surveyjs.io/form-library/documentation/api-reference/iaction#iconName), [tooltip](https://surveyjs.io/form-library/documentation/api-reference/iaction#tooltip), and other parameters. You should also specify a function that this button will call and assign it to the [`action`](https://surveyjs.io/form-library/documentation/api-reference/iaction#action) property. In this demo, the `action` function sets the Survey Creator's [`JSON`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#JSON) property to an empty object, thus clearing the survey users configure. 

```js
import { Action } from "survey-core";

const clearSurveyAction = new Action({
    id: "clear-survey",
    tooltip: "Clear Survey",
    iconName: "icon-clear-24x24",
    action: () => {
        creator.JSON = {};
    }
});
```

Different tabs can have different toolbar buttons. To control the toolbar button visibility, use the `IAction` object's [`visible`](https://surveyjs.io/form-library/documentation/api-reference/iaction#visible) property. You can set it to a static Boolean value or to a `ComputedUpdater` instance if you need to calculate the property value dynamically. The `ComputedUpdater` constructor accepts a function that specifies the calculation rules. This function will be reevaluated each time a dependency property is changed. In this demo, the `visible` property depends on the Survey Creator's [`activeTab`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#activeTab) property:

```js
const clearSurveyAction = new Action({
    // ...
    visible: new ComputedUpdater(() => creator.activeTab === "designer")
});
```

## Add the Button to the Toolbar

Survey Creator includes two toolbars: top (for the desktop view) and bottom (for the mobile view). You can add your custom button to both or only one of the toolbars: 

```js
// Add a custom button to the top toolbar
creator.toolbar.actions.push(clearSurveyAction);

// Add a custom button to the bottom toolbar
creator.footerToolbar.actions.push(clearSurveyAction);
```

Open the Code tab to view the code example in full.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Action, ComputedUpdater } from "survey-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator();
    const clearSurveyAction = new Action({
        id: "clear-survey",
        tooltip: "Clear Survey",
        iconName: "icon-clear-24x24",
        visible: new ComputedUpdater(() => creator.activeTab === "designer"),
        action: () => {
            creator.JSON = {};
        }
    });
    
    // Add a custom button to the top toolbar
    creator.toolbar.actions.push(clearSurveyAction);
    
    // Add a custom button to the bottom toolbar (visible only on mobile devices)
    creator.footerToolbar.actions.push(clearSurveyAction);
    
    creator.JSON = {
        "pages": [{
            "name": "page1",
            "elements": [{
                "type": "text",
                "name": "question1"
            }]
        }]
    };
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/toolbar-customization/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/toolbar-customization/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/toolbar-customization/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/toolbar-customization/vanillajs.md)
